; ----------------------------------------------------------------------------
; Object 4C - Attracted ring (ported from Sonic and Knuckles)
; ----------------------------------------------------------------------------
Obj4C:
	moveq	#0,d0
	move.b	routine(a0),d0
	move.w	Obj_4C_subtbl(pc,d0.w),d1
	jmp	Obj_4C_subtbl(pc,d1.w)
; ===========================================================================
Obj_4C_subtbl:
	dc.w	Obj_4C_sub_0-Obj_4C_subtbl; 0
	dc.w	Obj_4C_sub_2-Obj_4C_subtbl; 2
	dc.w	Obj_4C_sub_4-Obj_4C_subtbl; 4
	dc.w	Obj_4C_sub_6-Obj_4C_subtbl; 6
	dc.w	Obj_4C_sub_8-Obj_4C_subtbl; 8
; ===========================================================================

Obj_4C_sub_0:
	addq.b	#2,routine(a0)
	move.w	x_pos(a0),objoff_32(a0)
	move.l	#Obj25_MapUnc_12382,mappings(a0)
	move.w	#$26BC,art_tile(a0)
	bsr.w	Adjust2PArtPointer
	move.b	#4,render_flags(a0)
	move.b	#2,priority(a0)
	move.b	#$47,collision_flags(a0)
	move.b	#8,width_pixels(a0)

Obj_4C_sub_2:
	bsr.w	Obj_4C_Move
	movea.w	parent(a0),a1
	btst	#0,status_secondary(a1)	; Change the #0 to #5 if you've ported the actual lightning shield
	bne.s	+
	move.b	#$37,(a0)	; Load object 37 (scattered rings)
	move.b	#2,routine(a0)
	move.b	#-1,(Ring_spill_anim_counter).w
+
	move.b	(Rings_anim_frame).w,mapping_frame(a0)
	;move.w	objoff_32(a0),d0
	bra.w	DisplaySprite
; ===========================================================================

Obj_4C_sub_4:
	addq.b	#2,routine(a0)
	move.b	#0,collision_flags(a0)
	move.b	#1,priority(a0)
	subq.w	#1,(Perfect_rings_left).w
	bsr.w	sub_11FC2

Obj_4C_sub_6:
	lea	(byte_1237A).l,a1
	bsr.w	AnimateSprite
	bra.w	DisplaySprite
; ===========================================================================

Obj_4C_sub_8:
	bra.w	DeleteObject

; ||||||||||||||| S U B	R O U T	I N E |||||||||||||||||||||||||||||||||||||||


Obj_4C_Move:
	movea.w	parent(a0),a1
	move.w	#$30,d1
	move.w	x_pos(a1),d0
	cmp.w	x_pos(a0),d0
	bcc.s	loc_1A954
	neg.w	d1
	tst.w	x_vel(a0)
	bmi.s	loc_1A95E
	add.w	d1,d1
	add.w	d1,d1
	bra.s	loc_1A95E
; ===========================================================================

loc_1A954:
	tst.w	x_vel(a0)
	bpl.s	loc_1A95E
	add.w	d1,d1
	add.w	d1,d1

loc_1A95E:
	add.w	d1,x_vel(a0)
	move.w	#$30,d1
	move.w	y_pos(a1),d0
	cmp.w	y_pos(a0),d0
	bcc.s	loc_1A97E
	neg.w	d1
	tst.w	y_vel(a0)
	bmi.s	loc_1A988
	add.w	d1,d1
	add.w	d1,d1
	bra.s	loc_1A988
; ===========================================================================

loc_1A97E:
	tst.w	y_vel(a0)
	bpl.s	loc_1A988
	add.w	d1,d1
	add.w	d1,d1

loc_1A988:
	add.w	d1,y_vel(a0)
	jmp	(ObjectMove).l
; ===========================================================================